; SPIRITUS SANCTUS 2 (2013) for realtime Csound5/6 - by Arthur B. Hunkins
;  requires MIDI device with 8 knobs/sliders

<Cabbage>
form size(551, 185), caption("Spiritus Sanctus 2 {2013} for Csound5/6 - Arthur B. Hunkins")
hslider bounds(42, 4, 467, 36), range(0, 16, 1, 1, 1), text("MIDI Channel #"), channel("chan"), fontcolour(220, 220, 220), colour("yellow"), tracker("cornflowerblue"), textbox(1)
label bounds(55, 42, 170, 11), text("0 = CC7 / channels 1-8")
hslider bounds(42, 61, 467, 36), range(0, 120, 20, 1, 1), text("1st Cont # {of 8}"), channel("ctrl"), fontcolour(220, 220, 220), colour("yellow"), tracker("cornflowerblue"), textbox(1)
label bounds(42, 111, 436, 12), text("Zero controllers / set sliders above / {move controllers to initial position}")
infobutton bounds(119, 141, 173, 25), text("Performance Information"), fontcolour("yellow"), colour(80, 80, 80), file("SpiritusSanctus2Cabbage.htm")
</Cabbage>

<CsoundSynthesizer>
<CsOptions>

-n -m0d -+rtmidi=null -M0 --expression-opt -+raw_controller_mode=1

</CsOptions>
<CsInstruments>

sr	=	44100
ksmps	=	100
nchnls  =       2   

        instr 1
   
kchan   chnget   "chan"
kctrl   chnget   "ctrl"            
kstart  changed  kchan, kctrl
	if kstart == 1 then
        event    "i", -2, 0, 0
        event    "i", -3, 0, 0
        event    "i", 2, 0, -1, kchan, kctrl
        event    "i", 3, 0, -1, kchan, kctrl
	endif
         
        endin

        instr 2
   
gkamp	ctrl7    (p4 == 0? 1: p4), (p4 == 0? 7: p5), 0, 1
gkamp   tab      gkamp * 511, 2
gkamp   =        gkamp * 12000
gkamp   port     gkamp, .1
kmul    ctrl7    (p4 == 0? 2: p4), (p4 == 0? 7: p5 + 1), 0, .82
kmul    port     kmul, .1
knh     ctrl7    (p4 == 0? 3: p4), (p4 == 0? 7: p5 + 2), 4, 20
gklh    ctrl7    (p4 == 0? 4: p4), (p4 == 0? 7: p5 + 3), 4, 10.1
gkamp2  ctrl7    (p4 == 0? 8: p4), (p4 == 0? 7: p5 + 7), 0, .6
kamp2   rspline  -gkamp2, gkamp2, .6 * gklh, gklh
kamp2   port     kamp2, .01 
aout    gbuzz    gkamp + (kamp2 * gkamp), 200, knh, gklh, kmul, 1
        outs     aout, aout * .7
        
        endin
        
        instr 3
   
kmul    ctrl7    (p4 == 0? 5: p4), (p4 == 0? 7: p5 + 4), 0, .82
kmul    port     kmul, .1
knh     ctrl7    (p4 == 0? 6: p4), (p4 == 0? 7: p5 + 5), 4, 20
kfreq   ctrl7    (p4 == 0? 7: p4), (p4 == 0? 7: p5 + 6), 0, .15
kfreq   port     kfreq, .01 
kamp2   rspline  -gkamp2, gkamp2, .6 * gklh, gklh
kamp2   port     kamp2, .01 
aout    gbuzz    gkamp + (kamp2 * gkamp), 200.05 + kfreq, knh, gklh, kmul, 1
        outs     aout * .7, aout
        
        endin
                
</CsInstruments>
<CsScore>

f1 0 16384 11 16 1 .012
f2 0 512 16 0 512 .8 1

i1 0 3600
i2 0 -1
i3 0 -1

</CsScore>
</CsoundSynthesizer> 